-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------

require("socket")
client = socket.connect("207.167.14.19",8998)
IRC = { }

function split(pString, pPattern)
	local Table = {} -- NOTE: use {n = 0} in Lua-5.0
	local fpat = "(.-)" .. pPattern
	local last_end = 1
	local s, e, cap = pString:find(fpat, 1)
	while s do
		if s ~= 1 or cap ~= "" then
			table.insert(Table,cap)
		end
		last_end = e+1
		s, e, cap = pString:find(fpat, last_end)
	end
	if last_end <= #pString then
		cap = pString:sub(last_end)
		table.insert(Table, cap)
	end
	return Table
end

function OnlineMission:StartActivity()
	if client == nil then
		print("")
		print("")
		print("|---------------| Cortex Command couldn't connect to the server! |---------------|")
		print("|---------------|               The activity will now terminate                  |---------------|")
		print("")
		print("")
	end
	ip = client:getsockname();
	self.ScreenChange = false;
	self.Flipped = 0;
	current = 1;
	self.ShootDelayTimer = Timer();
	self.UpdateTimer = Timer();
	self.TextTimer = Timer();
	self.PlayerN = 0;
	self.Plyer = {};
--	self.PlayerCount = 1;
	screenTimer = Timer()
	saytimer = Timer()
	self.Updates = 0;
	lines = 9
	messages = { }
	msg = nil
	verbose = false
	total = ""
	name = "CCLUA"..math.floor(math.random()*1000)
	self.Team1Score = 0;
	self.Team2Score = 0;
	--		client:send(Var1 .. " " .. Var2 .. " " .. Var3 .. "\n");
	client:send(33 .. "\n");
	client:settimeout(1);
	self.Step = 0;
	Host = false;
			local connmsg, err = client:receive("*l")
	print(connmsg);
	if connmsg ~= nil then
		if string.find(connmsg,"Host ") ~= nil then
			Host = true;
			self.PlayerN = 1;
			print("YOU ARE THE PLAYER 1.");
		elseif string.find(connmsg,"Server Full ") ~= nil then
			print("SORRY THE SERVER IS FULL, NO PLAYING FOR YOU, BUT FEEL FREE TO SPECTATE.");
			self.PlayerN = 0;
		elseif string.find(connmsg,"Host ") ~= true and tonumber(connmsg) <= 4 then
			Host = false;
			self.PlayerN = tonumber(connmsg);
--			self.PlayerCount = self.PlayerN;
			print("You are player " .. self.PlayerN .. ".");
		else
			local connmsg, err = client:receive("*l")
			if connmsg ~= nil then
				if string.find(connmsg,"Host ") ~= nil then
					Host = true;
					self.PlayerN = 1;
					print("YOU ARE THE PLAYER 1.");
				elseif string.find(connmsg,"Server Full ") ~= nil then
					print("SORRY THE SERVER IS FULL, NO PLAYING FOR YOU, BUT FEEL FREE TO SPECTATE.");
					self.PlayerN = 0;
				elseif string.find(connmsg,"Host ") ~= true and tonumber(connmsg) <= 4 then
					Host = false;
					self.PlayerN = tonumber(connmsg);
--					self.PlayerCount = self.PlayerN;
					print("You are player " .. self.PlayerN .. ".");
				else
					print("TRY JOINING AGAIN");
				end
			end
		end
	else
		print(err);
	end
		self.Shoot = 0;
	self.Player = CreateAHuman("Soldier Light", "Coalition.rte");
	if self.PlayerN == 1 or self.PlayerN == 3 then
	    	self.Player.Pos = Vector(144, 300);
		self.Player.Team = 0;
		self.Brain = CreateActor("Brain Case");
	    	self.Brain.Pos = Vector(0, -999);
		self.Brain.Team = 0;
		self.Player.HFlipped = false;
	    	MovableMan:AddActor(self.Brain);
	else
	    	self.Player.Pos = Vector(1824, 288);
		self.Player.Team = 1;
		self.Brain = CreateActor("Brain Case");
	    	self.Brain.Pos = Vector(2000, -999);
		self.Brain.Team = 1; 
		self.Player.HFlipped = true;
	    	MovableMan:AddActor(self.Brain);
	end
	local gun = CreateHDFirearm("Laser Gun");
	self.Player:AddInventoryItem(gun);
	MovableMan:AddActor(self.Player);
	--------------------------
	-- Set up players
	for player = 0, 2, 1 do
	        -- Check if we already have a brain assigned
	        if not self:GetPlayerBrain(player) then
			local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
			self:SetPlayerBrain(self.Brain, player);
			self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
  			self:SetObservationTarget(self.Brain.Pos, player)
	        end
	end
	
	    
	    -- Set up AI modes
	client:settimeout(0.01);
	ActivityMan:GetActivity():SetTeamFunds(0,0)
end
	
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------

function OnlineMission:PauseActivity(pause)
	if self.PlayerN > 0 then
		client:send(40 .. " " .. self.PlayerN .. "\n");
	end
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------

function OnlineMission:EndActivity()
	if self.PlayerN > 0 then
		client:send(40 .. " " .. self.PlayerN .. "\n");
	end
end

-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------

function OnlineMission:UpdateActivity()
    	self:ClearObjectivePoints();
	for i=1,4,1 do
		if MovableMan:IsActor(self.Plyer[i]) then
			self:AddObjectivePoint(self.Plyer[i].SName, self.Plyer[i].AboveHUDPos, Activity.TEAM_1, GameActivity.ARROWDOWN);
			self.Plyer[i].RotAngle = 0;
		end
	end
		self.Sent = false;
		if MovableMan:IsActor(self.Player) then
			if not self.Player:IsPlayerControlled() then
				ActivityMan:GetActivity():SwitchToActor(self.Player, Activity.PLAYER_1, 0);
			end
			self.Player.RotAngle = 0;
			if self.UpdateTimer:IsPastRealMS(100) and self.PlayerN > 0  then
				if self.Player.HFlipped == true then
					self.Flipped = 1;
				else
					self.Flipped = 0;
				end
				client:send(self.PlayerN .. " " .. math.ceil(self.Player.Pos.X) .. " " .. math.ceil(self.Player.Pos.Y) .. " " .. math.ceil(self.Player.Vel.X) .. " " .. math.ceil(self.Player.Vel.Y) .. " " .. self.Flipped .. " " .. math.ceil(self.Player:GetAimAngle(false)*1000) .. " " .. self.Player.Health .. " " .. self.Shoot .. "\n");
				self.UpdateTimer:Reset();
			end
			if self.Player:GetController():IsState(Controller.WEAPON_FIRE) and self.PlayerN > 0  then
				if self.Shot == false then
					self.Shot = true;
					client:send(self.PlayerN .. " " .. math.ceil(self.Player.Pos.X) .. " " .. math.ceil(self.Player.Pos.Y) .. " " .. math.ceil(self.Player.Vel.X) .. " " .. math.ceil(self.Player.Vel.Y) .. " " .. self.Flipped .. " " .. math.ceil(self.Player:GetAimAngle(false)*1000) .. " " .. self.Player.Health .. " " .. 1 ..  "\n");
--					print("Shot");
				end
			else
				self.Shot = false;
			end
			if not self.Player:HasObject("Laser Gun") then
    				local gun = CreateHDFirearm("Laser Gun");
    				self.Player:AddInventoryItem(gun);
			end
			if (self.PlayerN == 1 or self.PlayerN == 3) and self.Player.Pos.X >= 1600 then
    				self.Player.Vel.X= -15;
  			elseif (self.PlayerN == 2 or self.PlayerN == 4) and self.Player.Pos.X <= 480 then
    				self.Player.Vel.X= 15;
    			end
		else
			self.Player = CreateAHuman("Soldier Light", "Coalition.rte");
			if self.PlayerN == 1 or self.PlayerN == 3 then
    				self.Player.Pos = Vector(100, 588);
				self.Player.Team = 0;
				self.Player.HFlipped = false;
  			else
    				self.Player.Pos = Vector(1900, 588);
				self.Player.Team = 1;
				self.Player.HFlipped = true;
    			end
    			local gun = CreateHDFirearm("Laser Gun", "Grimston.rte");
    			self.Player:AddInventoryItem(gun);
			MovableMan:AddActor(self.Player);
			client:send(50 .. " " .. self.PlayerN .. "\n");
		end

msg = client:receive("*l");
 if(msg ~= nil) then
	local Data = split(msg, ",");
	if tonumber(Data[1]) ~= self.PlayerN and tonumber(Data[1]) <= 4 then
			if MovableMan:IsActor(self.Plyer[tonumber(Data[1])]) then
				self.Plyer[tonumber(Data[1])].Pos = Vector(tonumber(Data[2]), tonumber(Data[3]));
				self.Plyer[tonumber(Data[1])].Vel = Vector(tonumber(Data[4]), tonumber(Data[5]));
--				print(Data[6]);
				if tonumber(Data[6]) == 1 then
					self.Plyer[tonumber(Data[1])].HFlipped = true;
				elseif tonumber(Data[6]) == 0 then
					self.Plyer[tonumber(Data[1])].HFlipped = false;	
				end
				self.Plyer[tonumber(Data[1])]:SetAimAngle(tonumber(Data[7])/1000);
--				print(tonumber(Data[7])/100);
				self.Plyer[tonumber(Data[1])].Health = tonumber(Data[8]);
				if tonumber(Data[9]) == 1 then
					self.Plyer[tonumber(Data[1])]:GetController():SetState(14,true);
				else
					self.Plyer[tonumber(Data[1])]:GetController():SetState(14,false);
				end
				if not self.Plyer[tonumber(Data[1])]:HasObject("Laser Gun") then
    					local gun1 = CreateHDFirearm("Laser Gun");
    					self.Plyer[tonumber(Data[1])]:AddInventoryItem(gun1);
				end
				self.Plyer[tonumber(Data[1])].SName = Data[1];
			else
--				print(tonumber(Data[1]));
				self.Plyer[tonumber(Data[1])] = CreateAHuman("Soldier Light", "Coalition.rte");
				if (self.PlayerN == 1 or self.PlayerN == 3) and (tonumber(Data[1]) == 1 or tonumber(Data[1]) == 3) then
    					self.Plyer[tonumber(Data[1])].Team = 0;
				else
    					self.Plyer[tonumber(Data[1])].Team = 1;
				end
--    				self.Plyer[tonumber(Data[1])].PinStrength = 100000;
				self.Plyer[tonumber(Data[1])].Pos = Vector(tonumber(Data[2]), tonumber(Data[3]));
    				self.Plyer[tonumber(Data[1])].InputMode = 3;
    				self.Plyer[tonumber(Data[1])]:SetControllerMode(Controller.CIM_PLAYER, 2);
    				local gun1 = CreateHDFirearm("Laser Gun", "Grimston.rte");
    				self.Plyer[tonumber(Data[1])]:AddInventoryItem(gun1);
    				MovableMan:AddActor(self.Plyer[tonumber(Data[1])]);
				self.Plyer[tonumber(Data[1])].SName = Data[1];
				client:send(60 .. " " .. Data[1] .. "\n");
			end
	end
	if ((tonumber(Data[1]) - 4) <= 4) and MovableMan:IsActor(self.Plyer[(tonumber(Data[1]) - 4)]) then
		self.Plyer[(tonumber(Data[1]) - 4)]:GibThis();
	end
	if 0 < (tonumber(Data[1]) - 100) and (tonumber(Data[1]) - 100) <= 4 then
		if (tonumber(Data[1]) - 100) == self.PlayerN and MovableMan:IsActor(self.Player) then
			self.Player:GibThis();
		end
	end
	if tonumber(Data[1]) == 42 then
		self.Team1Score = tonumber(Data[2]);
		print("Team 1: " .. self.Team1Score);
	elseif tonumber(Data[1]) == 43 then
		self.Team2Score = tonumber(Data[2]);
		print("Team 2: " .. self.Team2Score);
	end
end


if(screenTimer:IsPastSimMS(10)) then
	FrameMan:ClearScreenText(Activity.PLAYER_1);
	FrameMan:SetScreenText(total,Activity.PLAYER_1,0,-1,false)
	screenTimer:Reset()
end
end